#!/usr/bin/env node

import program from 'commander';
import {argv} from 'optimist';
import easyMockServer from './easyMockServer';


program
    .option("-p, --port <string>", "Server port")
    .option("-b, --basePath <string>", "File path");

program.parse(process.argv);

const configs = {
    basePath: program.basePath ? program.basePath : process.cwd(),
    port: program.port ? program.port : 8124,
};

const server = new easyMockServer(configs);
server.start();